// made by http://kldp.org/minipage/primewizard
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DIFE.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#include "../EmacsHooker/EmacsHooker.h"

#define  WM_ICON_NOTIFY  WM_USER+3


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_MESSAGE(WM_ICON_NOTIFY, OnTrayNotification)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	this->notifyicondata.cbSize = sizeof(NOTIFYICONDATA);
	//this->notifyicondata.dwInfoFlags;
	//this->notifyicondata.dwState;
	//this->notifyicondata.dwStateMask;
	this->notifyicondata.hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	this->notifyicondata.hWnd = this->GetSafeHwnd();
	//this->notifyicondata.szInfo;
	//this->notifyicondata.szInfoTitle;
	//this->notifyicondata.szTip;
	strcpy(this->notifyicondata.szTip, _T("Disable IME for Emacs"));
	this->notifyicondata.uCallbackMessage = WM_ICON_NOTIFY;
	this->notifyicondata.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
	this->notifyicondata.uID = IDR_MAINFRAME;
	//this->notifyicondata.uTimeout;
	//this->notifyicondata.uVersion;

	Shell_NotifyIcon(NIM_ADD, &(this->notifyicondata));

	InstallHook();

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers
LRESULT CMainFrame::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
	CMenu menu, *pSubMenu;

	if ( LOWORD(lParam) == WM_RBUTTONUP )
	{
		if (!menu.LoadMenu(IDR_MAINFRAME)) 
			return 0;
		if (!(pSubMenu = menu.GetSubMenu(0)))
			return 0;

		CPoint pos;
		::GetCursorPos(&pos);
		this->SetForegroundWindow();

		pSubMenu->TrackPopupMenu(TPM_RIGHTALIGN, pos.x, pos.y, this);

		menu.DestroyMenu();
	}
	else if ( LOWORD(lParam) == WM_LBUTTONDBLCLK ) 
	{
		SendMessage(WM_COMMAND, ID_APP_ABOUT);
	}

	return 1;
}
BOOL CMainFrame::DestroyWindow()
{
	// TODO: Add your specialized code here and/or call the base class

	UninstallHook();

	Shell_NotifyIcon(NIM_DELETE, &(this->notifyicondata));

	return CFrameWnd::DestroyWindow();
}
